From: Mimi Zohar <zohar@linux.ibm.com>
To: linux-integrity@vger.kernel.org
Cc: Mimi Zohar <zohar@linux.ibm.com>, Petr Vorel <pvorel@suse.cz>,
Vitaly Chikunov <vt@altlinux.org>,
Bruno Meneguele <bmeneg@redhat.com>
Subject: [ima-evm-utils][PATCH] Install the swtpm package, if available
Date: Sun, 16 Aug 2020 15:36:27 -0400 [thread overview]
Message-ID: <20200816193627.73935-1-zohar@linux.ibm.com> (raw)
The "boot_aggregate.test" requires either a hardware or software TPM.
Support using the swtpm, if packaged for the distro, in addition to
tpm_server.
Note: Some travis/<distro>.sh scripts are links to other scripts.
Don't fail the build of the linked script if the swtpm package doesn't
exist.
Signed-off-by: Mimi Zohar <zohar@linux.ibm.com>
---
.travis.yml | 2 +-
tests/boot_aggregate.test | 40 ++++++++++++++++++++++++++++-----------
travis/fedora.sh | 1 +
3 files changed, 31 insertions(+), 12 deletions(-)
diff --git a/.travis.yml b/.travis.yml
index 849fcb6ba822..9bea5d19bd0e 100644
--- a/.travis.yml
+++ b/.travis.yml
@@ -75,4 +75,4 @@ before_install:
script:
- INSTALL="${DISTRO%%:*}"
- INSTALL="${INSTALL%%/*}"
- - docker run -t ima-evm-utils /bin/sh -c "cd travis && if [ \"$VARIANT\" ]; then ARCH=\"$ARCH\" ./$INSTALL.$VARIANT.sh; fi && ARCH=\"$ARCH\" CC=\"$CC\" TSS=\"$TSS\" ./$INSTALL.sh && if [ ! \"$VARIANT\" ]; then which tpm_server || ../tests/install-swtpm.sh; fi && CC=\"$CC\" VARIANT=\"$VARIANT\" ../build.sh"
+ - docker run -t ima-evm-utils /bin/sh -c "cd travis && if [ \"$VARIANT\" ]; then ARCH=\"$ARCH\" ./$INSTALL.$VARIANT.sh; fi && ARCH=\"$ARCH\" CC=\"$CC\" TSS=\"$TSS\" ./$INSTALL.sh && if [ ! \"$VARIANT\" ]; then which tpm_server || which swtpm || ../tests/install-swtpm.sh; fi && CC=\"$CC\" VARIANT=\"$VARIANT\" ../build.sh"
diff --git a/tests/boot_aggregate.test b/tests/boot_aggregate.test
index 43de67de1468..ce310b6ae5b4 100755
--- a/tests/boot_aggregate.test
+++ b/tests/boot_aggregate.test
@@ -33,6 +33,10 @@ else
ASCII_RUNTIME_MEASUREMENTS="./sample-ascii_runtime_measurements-pcrs-8-9"
export TPM_INTERFACE_TYPE="socsim"
export TPM_COMMAND_PORT=2321
+ export TPM_PLATFORM_PORT=2322
+ export TPM_SERVER_NAME="localhost"
+ export TPM_SERVER_TYPE="raw"
+
fi
# Only stop this test's software TPM. Preferred method: "tsstpmcmd -stop"
@@ -48,22 +52,36 @@ cleanup() {
# Try to start a software TPM if needed.
swtpm_start() {
- local swtpm
+ local swtpm swtpm1
swtpm="$(which tpm_server)"
- if [ -z "${swtpm}" ]; then
- echo "${CYAN}SKIP: Softare TPM (tpm_server) not found${NORM}"
+ swtpm1="$(which swtpm)"
+ if [ -z "${swtpm}" ] && [ -z "${swptm1}" ]; then
+ echo "${CYAN}SKIP: Softare TPM (tpm_server and swtpm) not found${NORM}"
return "$SKIP"
fi
- pgrep tpm_server
- if [ $? -eq 0 ]; then
- echo "INFO: Software TPM (tpm_server) already running"
- return 114
- else
- echo "INFO: Starting software TPM: ${swtpm}"
- ${swtpm} > /dev/null 2>&1 &
- SWTPM_PPID=$!
+ if [ ! -z "${swtpm1}" ]; then
+ pgrep swtpm1
+ if [ $? -eq 0 ]; then
+ echo "INFO: Software TPM (swtpm) already running"
+ return 114
+ else
+ echo "INFO: Starting software TPM: ${swtpm1}"
+ mkdir ./myvtpm
+ ${swtpm1} socket --tpmstate dir=./myvtpm --tpm2 --ctrl type=tcp,port=2322 --server type=tcp,port=2321 --flags not-need-init > /dev/null 2>&1 &
+ SWTPM_PPID=$!
+ fi
+ elif [ ! -z "${swtpm}" ]; then
+ pgrep swtpm
+ if [ $? -eq 0 ]; then
+ echo "INFO: Software TPM (tpm_server) already running"
+ return 114
+ else
+ echo "INFO: Starting software TPM: ${swtpm}"
+ ${swtpm} > /dev/null 2>&1 &
+ SWTPM_PPID=$!
+ fi
fi
return 0
}
diff --git a/travis/fedora.sh b/travis/fedora.sh
index d3459e408d81..f9ee9bed7bc1 100755
--- a/travis/fedora.sh
+++ b/travis/fedora.sh
@@ -41,6 +41,7 @@ yum -y install \
which
yum -y install docbook5-style-xsl || true
+yum -y install swtpm || true
# FIXME: debug
echo "find /tss2_esys.h"
--
2.18.4
next reply other threads:[~2020-08-16 19:36 UTC|newest]
Thread overview: 5+ messages / expand[flat|nested] mbox.gz Atom feed top
2020-08-16 19:36 Mimi Zohar [this message]
2020-08-16 20:32 ` [ima-evm-utils][PATCH] Install the swtpm package, if available Mimi Zohar
2020-08-17 9:11 ` Petr Vorel
2020-08-17 14:31 ` Bruno Meneguele
2020-08-17 18:11 ` Stefan Berger
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=20200816193627.73935-1-zohar@linux.ibm.com \
--to=zohar@linux.ibm.com \
--cc=bmeneg@redhat.com \
--cc=linux-integrity@vger.kernel.org \
--cc=pvorel@suse.cz \
--cc=vt@altlinux.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox